Skip to content
v2.274.0

CfnLogGroup L1 construct ​

The AWS::Logs::LogGroup resource specifies a log group.

A log group defines common properties for log streams, such as their retention and access control rules. Each log stream must belong to one log group.

You can create up to 1,000,000 log groups per Region per account. You must use the following guidelines when naming a log group:

  • Log group names must be unique within a Region for an AWS account.
  • Log group names can be between 1 and 512 characters long.
  • Log group names consist of the following characters: a-z, A-Z, 0-9, '_' (underscore), '-' (hyphen), '/' (forward slash), and '.' (period).

Example ​

ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_logs as logs } from 'aws-cdk-lib';

declare const dataProtectionPolicy: any;
declare const fieldIndexPolicies: any;
declare const resourcePolicyDocument: any;
const cfnLogGroup = new logs.CfnLogGroup(this, 'MyCfnLogGroup', /* all optional props */ {
  bearerTokenAuthenticationEnabled: false,
  dataProtectionPolicy: dataProtectionPolicy,
  deletionProtectionEnabled: false,
  fieldIndexPolicies: [fieldIndexPolicies],
  kmsKeyId: 'kmsKeyId',
  logGroupClass: 'logGroupClass',
  logGroupName: 'logGroupName',
  resourcePolicyDocument: resourcePolicyDocument,
  retentionInDays: 123,
  tags: [{
    key: 'key',
    value: 'value',
  }],
});
python
from aws_cdk import CfnTag
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_logs as logs

# data_protection_policy: Any
# field_index_policies: Any
# resource_policy_document: Any

cfn_log_group = logs.CfnLogGroup(self, "MyCfnLogGroup",
    bearer_token_authentication_enabled=False,
    data_protection_policy=data_protection_policy,
    deletion_protection_enabled=False,
    field_index_policies=[field_index_policies],
    kms_key_id="kmsKeyId",
    log_group_class="logGroupClass",
    log_group_name="logGroupName",
    resource_policy_document=resource_policy_document,
    retention_in_days=123,
    tags=[CfnTag(
        key="key",
        value="value"
    )]
)
java
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.logs.*;

Object dataProtectionPolicy;
Object fieldIndexPolicies;
Object resourcePolicyDocument;

CfnLogGroup cfnLogGroup = CfnLogGroup.Builder.create(this, "MyCfnLogGroup")
        .bearerTokenAuthenticationEnabled(false)
        .dataProtectionPolicy(dataProtectionPolicy)
        .deletionProtectionEnabled(false)
        .fieldIndexPolicies(List.of(fieldIndexPolicies))
        .kmsKeyId("kmsKeyId")
        .logGroupClass("logGroupClass")
        .logGroupName("logGroupName")
        .resourcePolicyDocument(resourcePolicyDocument)
        .retentionInDays(123)
        .tags(List.of(CfnTag.builder()
                .key("key")
                .value("value")
                .build()))
        .build();
csharp
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.Logs;

var dataProtectionPolicy;
var fieldIndexPolicies;
var resourcePolicyDocument;

var cfnLogGroup = new CfnLogGroup(this, "MyCfnLogGroup", new CfnLogGroupProps {
    BearerTokenAuthenticationEnabled = false,
    DataProtectionPolicy = dataProtectionPolicy,
    DeletionProtectionEnabled = false,
    FieldIndexPolicies = new [] { fieldIndexPolicies },
    KmsKeyId = "kmsKeyId",
    LogGroupClass = "logGroupClass",
    LogGroupName = "logGroupName",
    ResourcePolicyDocument = resourcePolicyDocument,
    RetentionInDays = 123,
    Tags = new [] { new CfnTag {
        Key = "key",
        Value = "value"
    } }
});
go
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"

var dataProtectionPolicy interface{}
var fieldIndexPolicies interface{}
var resourcePolicyDocument interface{}

cfnLogGroup := awscdk.Aws_logs.NewCfnLogGroup(this, jsii.String("MyCfnLogGroup"), &CfnLogGroupProps{
	BearerTokenAuthenticationEnabled: jsii.Boolean(false),
	DataProtectionPolicy: dataProtectionPolicy,
	DeletionProtectionEnabled: jsii.Boolean(false),
	FieldIndexPolicies: []interface{}{
		fieldIndexPolicies,
	},
	KmsKeyId: jsii.String("kmsKeyId"),
	LogGroupClass: jsii.String("logGroupClass"),
	LogGroupName: jsii.String("logGroupName"),
	ResourcePolicyDocument: resourcePolicyDocument,
	RetentionInDays: jsii.Number(123),
	Tags: []CfnTag{
		&CfnTag{
			Key: jsii.String("key"),
			Value: jsii.String("value"),
		},
	},
})

Initializer ​

ts
new CfnLogGroup(scope: Construct, id: string, props?: CfnLogGroupProps)
python
CfnLogGroup(scope: Construct, id: str, props: typing.Optional[CfnLogGroupProps] = None)
java
new CfnLogGroup(Construct scope, String id, CfnLogGroupProps props)
csharp
new CfnLogGroup(Construct scope, string id, CfnLogGroupProps? props = null)
go
NewCfnLogGroup(Scope Construct, Id *string, Props CfnLogGroupProps)

Construct Props ​

bearerTokenAuthenticationEnabledoptionalboolean | IResolvablebearer_token_authentication_enabledoptionaltyping.Union[bool, IResolvable]bearerTokenAuthenticationEnabledoptionalBooleanBearerTokenAuthenticationEnabledoptionalboolBearerTokenAuthenticationEnabledoptionalinterface{}= false#
Indicates whether bearer token authentication is enabled for this log group.

When enabled, bearer token authentication is allowed on operations until it is explicitly disabled.

dataProtectionPolicyoptionalanydata_protection_policyoptionalAnydataProtectionPolicyoptionalObjectDataProtectionPolicyoptionalobjectDataProtectionPolicyoptionalinterface{}#
Creates a data protection policy and assigns it to the log group.
notes

A data protection policy can help safeguard sensitive data that's ingested by the log group by auditing and masking the sensitive log data. When a user who does not have permission to view masked data views a log event that includes masked data, the sensitive data is replaced by asterisks.

deletionProtectionEnabledoptionalboolean | IResolvabledeletion_protection_enabledoptionaltyping.Union[bool, IResolvable]deletionProtectionEnabledoptionalBooleanDeletionProtectionEnabledoptionalboolDeletionProtectionEnabledoptionalinterface{}= false#
Indicates whether deletion protection is enabled for this log group.

When enabled, deletion protection blocks all deletion operations until it is explicitly disabled.

fieldIndexPoliciesoptionalany[] | IResolvablefield_index_policiesoptionaltyping.Union[typing.List[Any], IResolvable]fieldIndexPoliciesoptionalList<Object>FieldIndexPoliciesoptionalobject[]FieldIndexPoliciesoptionalinterface{}#
Creates or updates a *field index policy* for the specified log group.
notes

Only log groups in the Standard log class support field index policies. For more information about log classes, see Log classes .

You can use field index policies to create field indexes on fields found in log events in the log group. Creating field indexes lowers the costs for CloudWatch Logs Insights queries that reference those field indexes, because these queries attempt to skip the processing of log events that are known to not match the indexed field. Good fields to index are fields that you often need to query for and fields that have high cardinality of values Common examples of indexes include request ID, session ID, userID, and instance IDs. For more information, see Create field indexes to improve query performance and reduce costs .

Currently, this array supports only one field index policy object.

kmsKeyIdoptionalstring | IKeyRefkms_key_idoptionaltyping.Union[str, IKeyRef]kmsKeyIdoptionalStringKmsKeyIdoptionalstringKmsKeyIdoptionalinterface{}#
The Amazon Resource Name (ARN) of the AWS key to use when encrypting log data.
notes

To associate an AWS key with the log group, specify the ARN of that KMS key here. If you do so, ingested data is encrypted using this key. This association is stored as long as the data encrypted with the KMS key is still within CloudWatch Logs . This enables CloudWatch Logs to decrypt this data whenever it is requested.

If you attempt to associate a KMS key with the log group but the KMS key doesn't exist or is deactivated, you will receive an InvalidParameterException error.

Log group data is always encrypted in CloudWatch Logs . If you omit this key, the encryption does not use AWS . For more information, see Encrypt log data in CloudWatch Logs using AWS Key Management Service

logGroupClassoptionalstringlog_group_classoptionalstrlogGroupClassoptionalStringLogGroupClassoptionalstringLogGroupClassoptional*string= "STANDARD"#
Specifies the log group class for this log group. There are two classes:.
notes
  • The Standard log class supports all CloudWatch Logs features.
  • The Infrequent Access log class supports a subset of CloudWatch Logs features and incurs lower costs.

For details about the features supported by each class, see Log classes

logGroupNameoptionalstring | IFunctionReflog_group_nameoptionaltyping.Union[str, IFunctionRef]logGroupNameoptionalStringLogGroupNameoptionalstringLogGroupNameoptionalinterface{}#
The name of the log group.

If you don't specify a name, AWS CloudFormation generates a unique ID for the log group.

resourcePolicyDocumentoptionalanyresource_policy_documentoptionalAnyresourcePolicyDocumentoptionalObjectResourcePolicyDocumentoptionalobjectResourcePolicyDocumentoptionalinterface{}#
Creates or updates a resource policy for the specified log group that allows other services to put log events to this account.

A LogGroup can have 1 resource policy.

retentionInDaysoptionalnumberretention_in_daysoptionalint | floatretentionInDaysoptionalNumberRetentionInDaysoptionaldoubleRetentionInDaysoptional*float64#
The number of days to retain the log events in the specified log group.

Possible values are: 1, 3, 5, 7, 14, 30, 60, 90, 120, 150, 180, 365, 400, 545, 731, 1096, 1827, 2192, 2557, 2922, 3288, and 3653.

To set a log group so that its log events do not expire, do not specify this property.

tagsoptionalCfnTag[]tagsoptionaltyping.List[CfnTag]tagsoptionalList<CfnTag>TagsoptionalCfnTag[]Tagsoptional*[]CfnTag#
An array of key-value pairs to apply to the log group.

For more information, see Tag .

Properties ​

attrArnstringattr_arnstrattrArnStringAttrArnstringAttrArn*stringrequired#
The ARN of the log group, such as `arn:aws:logs:us-west-1:123456789012:log-group:/mystack-testgroup-12ABC1AB12A1:*`.
bearerTokenAuthenticationEnabledmay be undefinedboolean | IResolvablebearer_token_authentication_enabledmay be undefinedtyping.Union[bool, IResolvable]bearerTokenAuthenticationEnabledmay be undefinedBooleanBearerTokenAuthenticationEnabledmay be undefinedboolBearerTokenAuthenticationEnabledmay be undefinedinterface{}#
Indicates whether bearer token authentication is enabled for this log group.
CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringrequiredstatic#
The CloudFormation resource type name for this resource class.
Options for this resource, such as condition, update policy etc.
cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*stringrequired#
AWS resource type.
creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*stringrequired#
dataProtectionPolicyanydata_protection_policyAnydataProtectionPolicyObjectDataProtectionPolicyobjectDataProtectionPolicyinterface{}required#
Creates a data protection policy and assigns it to the log group.
deletionProtectionEnabledmay be undefinedboolean | IResolvabledeletion_protection_enabledmay be undefinedtyping.Union[bool, IResolvable]deletionProtectionEnabledmay be undefinedBooleanDeletionProtectionEnabledmay be undefinedboolDeletionProtectionEnabledmay be undefinedinterface{}#
Indicates whether deletion protection is enabled for this log group.
fieldIndexPoliciesmay be undefinedany[] | IResolvablefield_index_policiesmay be undefinedtyping.Union[typing.List[Any], IResolvable]fieldIndexPoliciesmay be undefinedList<Object>FieldIndexPoliciesmay be undefinedobject[]FieldIndexPoliciesmay be undefinedinterface{}#
Creates or updates a *field index policy* for the specified log group.
kmsKeyIdmay be undefinedstringkms_key_idmay be undefinedstrkmsKeyIdmay be undefinedStringKmsKeyIdmay be undefinedstringKmsKeyIdmay be undefined*string#
The Amazon Resource Name (ARN) of the AWS key to use when encrypting log data.
logGroupClassmay be undefinedstringlog_group_classmay be undefinedstrlogGroupClassmay be undefinedStringLogGroupClassmay be undefinedstringLogGroupClassmay be undefined*string#
Specifies the log group class for this log group.

There are two classes:.

logGroupNamemay be undefinedstringlog_group_namemay be undefinedstrlogGroupNamemay be undefinedStringLogGroupNamemay be undefinedstringLogGroupNamemay be undefined*string#
The name of the log group.
logGroupRefLogGroupReferencelog_group_refLogGroupReferencelogGroupRefLogGroupReferenceLogGroupRefLogGroupReferenceLogGroupRefLogGroupReferencerequired#
A reference to a LogGroup resource.
logicalIdstringlogical_idstrlogicalIdStringLogicalIdstringLogicalId*stringrequired#
The logical ID for this CloudFormation stack element.

The logical ID of the element is calculated from the path of the resource node in the construct tree.

To override this value, use overrideLogicalId(newLogicalId).

nodeNodenodeNodenodeNodeNodeNodeNodeNoderequired#
The tree node.
refstringrefstrrefStringRefstringRef*stringrequired#
Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).

resourcePolicyDocumentanyresource_policy_documentAnyresourcePolicyDocumentObjectResourcePolicyDocumentobjectResourcePolicyDocumentinterface{}required#
Creates or updates a resource policy for the specified log group that allows other services to put log events to this account.
retentionInDaysmay be undefinednumberretention_in_daysmay be undefinedint | floatretentionInDaysmay be undefinedNumberRetentionInDaysmay be undefineddoubleRetentionInDaysmay be undefined*float64#
The number of days to retain the log events in the specified log group.
stackStackstackStackstackStackStackStackStackStackrequired#
The stack in which this element is defined.

CfnElements must be defined within a stack scope (directly or indirectly).

Tag Manager which manages the tags for this resource.
tagsRawmay be undefinedCfnTag[]tags_rawmay be undefinedtyping.List[CfnTag]tagsRawmay be undefinedList<CfnTag>TagsRawmay be undefinedCfnTag[]TagsRawmay be undefined*[]CfnTag#
An array of key-value pairs to apply to the log group.

Methods ​

addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#
Syntactic sugar for `addOverride(path, undefined)`.
1 parameter

Parameters

  • pathpathpathpathPath — The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#
Use `addResourceDependency` instead.

This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.

addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#
Use `addResourceDependency` instead.
notes

This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.

This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.

addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#
Add a value to the CloudFormation Resource Metadata.
addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#
Adds an override to the synthesized CloudFormation resource.
notes · 2 parameters

To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).

If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.

To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.

For example,

typescript
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');

would add the overrides

json
"Properties": {
  "GlobalSecondaryIndexes": [
    {
      "Projection": {
        "NonKeyAttributes": [ "myattribute" ]
        ...
      }
      ...
    },
    {
      "ProjectionType": "INCLUDE"
      ...
    },
  ]
  ...
}

The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.

Parameters

  • pathpathpathpathPath — - The path of the property, you can use dot notation to override values in complex types.
  • valuevaluevaluevalueValue — - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#
Adds an override that deletes the value of a property from the resource definition.
1 parameter

Parameters

  • propertyPathproperty_pathpropertyPathpropertyPathPropertyPath — The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#
Adds an override to a resource property.

Syntactic sugar for addOverride("Properties.<...>", value).

2 parameters

Parameters

  • propertyPathproperty_pathpropertyPathpropertyPathPropertyPath — The path of the property.
  • valuevaluevaluevalueValue — The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#
Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.
notes

This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.

This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.

applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#
Sets the cross-stack reference strength for this resource.

When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.

1 parameter

Parameters

  • strengthstrengthstrengthstrengthStrength — - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#
Sets the deletion policy of the resource based on the removal policy specified.
notes

The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.

The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:

arnForLogGroup(resource: ILogGroupRef): string@staticmethod def arn_for_log_group(resource: ILogGroupRef) -> strpublic static String arnForLogGroup(ILogGroupRef resource)public static string ArnForLogGroup(ILogGroupRef resource)func ArnForLogGroup(Resource ILogGroupRef) *stringstatic#
cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#
fromLogGroupArn(scope: Construct, id: string, arn: string): ILogGroupRef@staticmethod def from_log_group_arn(scope: Construct, id: str, arn: str) -> ILogGroupRefpublic static ILogGroupRef fromLogGroupArn(Construct scope, String id, String arn)public static ILogGroupRef FromLogGroupArn(Construct scope, string id, string arn)func FromLogGroupArn(Scope Construct, Id *string, Arn *string) ILogGroupRefstatic#
Creates a new ILogGroupRef from an ARN.
fromLogGroupName(scope: Construct, id: string, logGroupName: string): ILogGroupRef@staticmethod def from_log_group_name(scope: Construct, id: str, log_group_name: str) -> ILogGroupRefpublic static ILogGroupRef fromLogGroupName(Construct scope, String id, String logGroupName)public static ILogGroupRef FromLogGroupName(Construct scope, string id, string logGroupName)func FromLogGroupName(Scope Construct, Id *string, LogGroupName *string) ILogGroupRefstatic#
Creates a new ILogGroupRef from a logGroupName.
getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#
Returns a token for an runtime attribute of this resource.

Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.

1 parameter

Parameters

  • attributeNameattribute_nameattributeNameattributeNameAttributeName — The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#
Retrieve a value value from the CloudFormation Resource Metadata.
inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#
Examines the CloudFormation resource and discloses attributes.
1 parameter

Parameters

  • inspectorinspectorinspectorinspectorInspector — tree inspector to collect and process attributes.
isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#
Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.

returns

Returns: The construct as a stack element or undefined if it is not a stack element.

isCfnLogGroup(x: any): boolean@staticmethod def is_cfn_log_group(x: Any) -> boolpublic static Boolean isCfnLogGroup(Object x)public static bool IsCfnLogGroup(object x)func IsCfnLogGroup(X interface{}) *boolstatic#
Checks whether the given object is a CfnLogGroup.
isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#
Check whether the given object is a CfnResource.
isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#
Checks if `x` is a construct.
notes · 1 parameter · returns

Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.

Parameters

  • xxxxX — Any object.

Returns: true if x is an object created from a class which extends Construct.

obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#
Retrieves an array of resources and stacks this resource depends on.

For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.

overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#
Overrides the auto-generated logical ID with a specific ID.
1 parameter

Parameters

  • newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId — The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#
Use `removeResourceDependency` instead

This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.

removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#
Indicates that this resource no longer depends on another resource.

This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.

replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#
Replaces one dependency with another.
2 parameters

Parameters

  • targettargettargettargetTarget — The dependency to replace.
  • newTargetnew_targetnewTargetnewTargetNewTarget — The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#
Returns a string representation of this construct.
returns

Returns: a string representation of this resource

with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#
Applies one or more mixins to this construct.

Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.